/*
Copyright 2021 The Kruise Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	context "context"

	v1alpha1 "github.com/openkruise/kruise/apis/apps/v1alpha1"
	appsv1alpha1 "github.com/openkruise/kruise/pkg/client/clientset/versioned/typed/apps/v1alpha1"
	autoscalingv1 "k8s.io/api/autoscaling/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	gentype "k8s.io/client-go/gentype"
	testing "k8s.io/client-go/testing"
)

// fakeStatefulSets implements StatefulSetInterface
type fakeStatefulSets struct {
	*gentype.FakeClientWithList[*v1alpha1.StatefulSet, *v1alpha1.StatefulSetList]
	Fake *FakeAppsV1alpha1
}

func newFakeStatefulSets(fake *FakeAppsV1alpha1, namespace string) appsv1alpha1.StatefulSetInterface {
	return &fakeStatefulSets{
		gentype.NewFakeClientWithList[*v1alpha1.StatefulSet, *v1alpha1.StatefulSetList](
			fake.Fake,
			namespace,
			v1alpha1.SchemeGroupVersion.WithResource("statefulsets"),
			v1alpha1.SchemeGroupVersion.WithKind("StatefulSet"),
			func() *v1alpha1.StatefulSet { return &v1alpha1.StatefulSet{} },
			func() *v1alpha1.StatefulSetList { return &v1alpha1.StatefulSetList{} },
			func(dst, src *v1alpha1.StatefulSetList) { dst.ListMeta = src.ListMeta },
			func(list *v1alpha1.StatefulSetList) []*v1alpha1.StatefulSet {
				return gentype.ToPointerSlice(list.Items)
			},
			func(list *v1alpha1.StatefulSetList, items []*v1alpha1.StatefulSet) {
				list.Items = gentype.FromPointerSlice(items)
			},
		),
		fake,
	}
}

// GetScale takes name of the statefulSet, and returns the corresponding scale object, and an error if there is any.
func (c *fakeStatefulSets) GetScale(ctx context.Context, statefulSetName string, options v1.GetOptions) (result *autoscalingv1.Scale, err error) {
	emptyResult := &autoscalingv1.Scale{}
	obj, err := c.Fake.
		Invokes(testing.NewGetSubresourceActionWithOptions(c.Resource(), c.Namespace(), "scale", statefulSetName, options), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*autoscalingv1.Scale), err
}

// UpdateScale takes the representation of a scale and updates it. Returns the server's representation of the scale, and an error, if there is any.
func (c *fakeStatefulSets) UpdateScale(ctx context.Context, statefulSetName string, scale *autoscalingv1.Scale, opts v1.UpdateOptions) (result *autoscalingv1.Scale, err error) {
	emptyResult := &autoscalingv1.Scale{}
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceActionWithOptions(c.Resource(), "scale", c.Namespace(), scale, opts), &autoscalingv1.Scale{})

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*autoscalingv1.Scale), err
}
