/*
Copyright 2021 The Kruise Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	appsv1alpha1 "github.com/openkruise/kruise/apis/apps/v1alpha1"
	labels "k8s.io/apimachinery/pkg/labels"
	listers "k8s.io/client-go/listers"
	cache "k8s.io/client-go/tools/cache"
)

// AdvancedCronJobLister helps list AdvancedCronJobs.
// All objects returned here must be treated as read-only.
type AdvancedCronJobLister interface {
	// List lists all AdvancedCronJobs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.AdvancedCronJob, err error)
	// AdvancedCronJobs returns an object that can list and get AdvancedCronJobs.
	AdvancedCronJobs(namespace string) AdvancedCronJobNamespaceLister
	AdvancedCronJobListerExpansion
}

// advancedCronJobLister implements the AdvancedCronJobLister interface.
type advancedCronJobLister struct {
	listers.ResourceIndexer[*appsv1alpha1.AdvancedCronJob]
}

// NewAdvancedCronJobLister returns a new AdvancedCronJobLister.
func NewAdvancedCronJobLister(indexer cache.Indexer) AdvancedCronJobLister {
	return &advancedCronJobLister{listers.New[*appsv1alpha1.AdvancedCronJob](indexer, appsv1alpha1.Resource("advancedcronjob"))}
}

// AdvancedCronJobs returns an object that can list and get AdvancedCronJobs.
func (s *advancedCronJobLister) AdvancedCronJobs(namespace string) AdvancedCronJobNamespaceLister {
	return advancedCronJobNamespaceLister{listers.NewNamespaced[*appsv1alpha1.AdvancedCronJob](s.ResourceIndexer, namespace)}
}

// AdvancedCronJobNamespaceLister helps list and get AdvancedCronJobs.
// All objects returned here must be treated as read-only.
type AdvancedCronJobNamespaceLister interface {
	// List lists all AdvancedCronJobs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.AdvancedCronJob, err error)
	// Get retrieves the AdvancedCronJob from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*appsv1alpha1.AdvancedCronJob, error)
	AdvancedCronJobNamespaceListerExpansion
}

// advancedCronJobNamespaceLister implements the AdvancedCronJobNamespaceLister
// interface.
type advancedCronJobNamespaceLister struct {
	listers.ResourceIndexer[*appsv1alpha1.AdvancedCronJob]
}
