/*
Copyright 2021 The Kruise Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	appsv1alpha1 "github.com/openkruise/kruise/apis/apps/v1alpha1"
	labels "k8s.io/apimachinery/pkg/labels"
	listers "k8s.io/client-go/listers"
	cache "k8s.io/client-go/tools/cache"
)

// BroadcastJobLister helps list BroadcastJobs.
// All objects returned here must be treated as read-only.
type BroadcastJobLister interface {
	// List lists all BroadcastJobs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.BroadcastJob, err error)
	// BroadcastJobs returns an object that can list and get BroadcastJobs.
	BroadcastJobs(namespace string) BroadcastJobNamespaceLister
	BroadcastJobListerExpansion
}

// broadcastJobLister implements the BroadcastJobLister interface.
type broadcastJobLister struct {
	listers.ResourceIndexer[*appsv1alpha1.BroadcastJob]
}

// NewBroadcastJobLister returns a new BroadcastJobLister.
func NewBroadcastJobLister(indexer cache.Indexer) BroadcastJobLister {
	return &broadcastJobLister{listers.New[*appsv1alpha1.BroadcastJob](indexer, appsv1alpha1.Resource("broadcastjob"))}
}

// BroadcastJobs returns an object that can list and get BroadcastJobs.
func (s *broadcastJobLister) BroadcastJobs(namespace string) BroadcastJobNamespaceLister {
	return broadcastJobNamespaceLister{listers.NewNamespaced[*appsv1alpha1.BroadcastJob](s.ResourceIndexer, namespace)}
}

// BroadcastJobNamespaceLister helps list and get BroadcastJobs.
// All objects returned here must be treated as read-only.
type BroadcastJobNamespaceLister interface {
	// List lists all BroadcastJobs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.BroadcastJob, err error)
	// Get retrieves the BroadcastJob from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*appsv1alpha1.BroadcastJob, error)
	BroadcastJobNamespaceListerExpansion
}

// broadcastJobNamespaceLister implements the BroadcastJobNamespaceLister
// interface.
type broadcastJobNamespaceLister struct {
	listers.ResourceIndexer[*appsv1alpha1.BroadcastJob]
}
