/*
Copyright 2021 The Kruise Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	appsv1alpha1 "github.com/openkruise/kruise/apis/apps/v1alpha1"
	labels "k8s.io/apimachinery/pkg/labels"
	listers "k8s.io/client-go/listers"
	cache "k8s.io/client-go/tools/cache"
)

// ContainerRecreateRequestLister helps list ContainerRecreateRequests.
// All objects returned here must be treated as read-only.
type ContainerRecreateRequestLister interface {
	// List lists all ContainerRecreateRequests in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.ContainerRecreateRequest, err error)
	// ContainerRecreateRequests returns an object that can list and get ContainerRecreateRequests.
	ContainerRecreateRequests(namespace string) ContainerRecreateRequestNamespaceLister
	ContainerRecreateRequestListerExpansion
}

// containerRecreateRequestLister implements the ContainerRecreateRequestLister interface.
type containerRecreateRequestLister struct {
	listers.ResourceIndexer[*appsv1alpha1.ContainerRecreateRequest]
}

// NewContainerRecreateRequestLister returns a new ContainerRecreateRequestLister.
func NewContainerRecreateRequestLister(indexer cache.Indexer) ContainerRecreateRequestLister {
	return &containerRecreateRequestLister{listers.New[*appsv1alpha1.ContainerRecreateRequest](indexer, appsv1alpha1.Resource("containerrecreaterequest"))}
}

// ContainerRecreateRequests returns an object that can list and get ContainerRecreateRequests.
func (s *containerRecreateRequestLister) ContainerRecreateRequests(namespace string) ContainerRecreateRequestNamespaceLister {
	return containerRecreateRequestNamespaceLister{listers.NewNamespaced[*appsv1alpha1.ContainerRecreateRequest](s.ResourceIndexer, namespace)}
}

// ContainerRecreateRequestNamespaceLister helps list and get ContainerRecreateRequests.
// All objects returned here must be treated as read-only.
type ContainerRecreateRequestNamespaceLister interface {
	// List lists all ContainerRecreateRequests in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.ContainerRecreateRequest, err error)
	// Get retrieves the ContainerRecreateRequest from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*appsv1alpha1.ContainerRecreateRequest, error)
	ContainerRecreateRequestNamespaceListerExpansion
}

// containerRecreateRequestNamespaceLister implements the ContainerRecreateRequestNamespaceLister
// interface.
type containerRecreateRequestNamespaceLister struct {
	listers.ResourceIndexer[*appsv1alpha1.ContainerRecreateRequest]
}
