/*
Copyright 2021 The Kruise Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	appsv1alpha1 "github.com/openkruise/kruise/apis/apps/v1alpha1"
	labels "k8s.io/apimachinery/pkg/labels"
	listers "k8s.io/client-go/listers"
	cache "k8s.io/client-go/tools/cache"
)

// ImagePullJobLister helps list ImagePullJobs.
// All objects returned here must be treated as read-only.
type ImagePullJobLister interface {
	// List lists all ImagePullJobs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.ImagePullJob, err error)
	// ImagePullJobs returns an object that can list and get ImagePullJobs.
	ImagePullJobs(namespace string) ImagePullJobNamespaceLister
	ImagePullJobListerExpansion
}

// imagePullJobLister implements the ImagePullJobLister interface.
type imagePullJobLister struct {
	listers.ResourceIndexer[*appsv1alpha1.ImagePullJob]
}

// NewImagePullJobLister returns a new ImagePullJobLister.
func NewImagePullJobLister(indexer cache.Indexer) ImagePullJobLister {
	return &imagePullJobLister{listers.New[*appsv1alpha1.ImagePullJob](indexer, appsv1alpha1.Resource("imagepulljob"))}
}

// ImagePullJobs returns an object that can list and get ImagePullJobs.
func (s *imagePullJobLister) ImagePullJobs(namespace string) ImagePullJobNamespaceLister {
	return imagePullJobNamespaceLister{listers.NewNamespaced[*appsv1alpha1.ImagePullJob](s.ResourceIndexer, namespace)}
}

// ImagePullJobNamespaceLister helps list and get ImagePullJobs.
// All objects returned here must be treated as read-only.
type ImagePullJobNamespaceLister interface {
	// List lists all ImagePullJobs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*appsv1alpha1.ImagePullJob, err error)
	// Get retrieves the ImagePullJob from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*appsv1alpha1.ImagePullJob, error)
	ImagePullJobNamespaceListerExpansion
}

// imagePullJobNamespaceLister implements the ImagePullJobNamespaceLister
// interface.
type imagePullJobNamespaceLister struct {
	listers.ResourceIndexer[*appsv1alpha1.ImagePullJob]
}
